Index: trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/ClientAdapter.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/ClientAdapter.cs	(revision 964)
+++ trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/ClientAdapter.cs	(revision 965)
@@ -45,4 +45,16 @@
 
         return resAdapter;
+      }
+    }
+
+    private IClientGroupAdapter clientGroupAdapter = null;
+
+    private IClientGroupAdapter ClientGroupAdapter {
+      get {
+        if (clientGroupAdapter == null) {
+          clientGroupAdapter = ServiceLocator.GetClientGroupAdapter();
+        }
+
+        return clientGroupAdapter;
       }
     }
@@ -159,4 +171,18 @@
     }
 
+    public ClientInfo GetClientById(long id) {
+      ClientInfo client = new ClientInfo();
+
+      dsHiveServer.ClientRow row = data.FindByResourceId(id);
+
+      if (row != null) {
+        Convert(row, client);
+
+        return client;
+      } else {
+        return null;
+      }
+    }
+
     public ICollection<ClientInfo> GetAllClients() {
       ICollection<ClientInfo> allClients =
@@ -173,5 +199,5 @@
 
     [MethodImpl(MethodImplOptions.Synchronized)]
-    public bool DeleteClient(ClientInfo client) {
+    public bool DeleteClient(ClientInfo client) {      
       if (client != null) {
         dsHiveServer.ClientRow row = null;
@@ -185,4 +211,12 @@
 
         if (row != null) {
+          ICollection<ClientGroup> clientGroups =
+            ClientGroupAdapter.MemberOf(client);
+
+          foreach (ClientGroup group in clientGroups) {
+            group.Resources.Remove(client);
+            ClientGroupAdapter.UpdateClientGroup(group);
+          }
+
           data.RemoveClientRow(row);
 
Index: trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/ClientGroupAdapter.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/ClientGroupAdapter.cs	(revision 964)
+++ trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/ClientGroupAdapter.cs	(revision 965)
@@ -27,23 +27,291 @@
 using HeuristicLab.Hive.Server.Core.InternalInterfaces.DataAccess;
 using HeuristicLab.Hive.Contracts.BusinessObjects;
+using System.Runtime.CompilerServices;
+using System.Data;
 
 namespace HeuristicLab.Hive.Server.ADODataAccess {
-  class ClientGroupAdapter: IClientGroupAdapter {
+  class ClientGroupAdapter : DataAdapterBase, IClientGroupAdapter {
+    private dsHiveServerTableAdapters.ClientGroupTableAdapter adapter =
+        new dsHiveServerTableAdapters.ClientGroupTableAdapter();
+
+    private dsHiveServer.ClientGroupDataTable data =
+      new dsHiveServer.ClientGroupDataTable();
+
+    private dsHiveServerTableAdapters.ClientGroup_ResourceTableAdapter resourceClientGroupAdapter =
+      new dsHiveServerTableAdapters.ClientGroup_ResourceTableAdapter();
+
+    private dsHiveServer.ClientGroup_ResourceDataTable resourceClientGroupData =
+      new dsHiveServer.ClientGroup_ResourceDataTable();
+
+    private IResourceAdapter resourceAdapter = null;
+
+    private IResourceAdapter ResourceAdapter {
+      get {
+        if (resourceAdapter == null)
+          resourceAdapter = ServiceLocator.GetResourceAdapter();
+
+        return resourceAdapter;
+      }
+    }
+
+    private IClientAdapter clientAdapter = null;
+
+    private IClientAdapter ClientAdapter {
+      get {
+        if (clientAdapter == null)
+          clientAdapter = ServiceLocator.GetClientAdapter();
+
+        return clientAdapter;
+      }
+    }
+
+    public ClientGroupAdapter() {
+      adapter.Fill(data);
+      resourceClientGroupAdapter.Fill(resourceClientGroupData);
+    }
+
+    protected override void Update() {
+      this.adapter.Update(this.data);
+      this.resourceClientGroupAdapter.Update(resourceClientGroupData);
+    }
+
+    private ClientGroup Convert(dsHiveServer.ClientGroupRow row,
+      ClientGroup clientGroup) {
+      if (row != null && clientGroup != null) {
+        /*Parent - Permission Owner*/
+        clientGroup.ResourceId = row.ResourceId;
+        ResourceAdapter.GetResourceById(clientGroup);
+
+        //first check for created references
+        IEnumerable<dsHiveServer.ClientGroup_ResourceRow> clientGroupRows =
+          from resource in
+            resourceClientGroupData.AsEnumerable<dsHiveServer.ClientGroup_ResourceRow>()
+          where resource.ClientGroupResource == clientGroup.ResourceId
+          select resource;
+
+        foreach (dsHiveServer.ClientGroup_ResourceRow resourceClientGroupRow in
+          clientGroupRows) {
+          Resource resource = null;
+
+          IEnumerable<Resource> resources =
+            from p in
+              clientGroup.Resources
+            where p.ResourceId == resourceClientGroupRow.ResourceId
+            select p;
+          if (resources.Count<Resource>() == 1)
+            resource = resources.First<Resource>();
+
+          if (resource == null) {
+            Resource res =
+              ClientAdapter.GetClientById(resourceClientGroupRow.ResourceId);
+
+            if (res == null) {
+              //is a client group
+              res =
+                GetClientGroupById(resourceClientGroupRow.ResourceId);
+            }
+
+            if (res != null)
+              clientGroup.Resources.Add(res);
+          }
+        }
+
+        //secondly check for deleted references
+        ICollection<Resource> deleted =
+          new List<Resource>();
+
+        foreach (Resource resource in clientGroup.Resources) {
+          dsHiveServer.ClientGroup_ResourceRow permOwnerUserGroupRow =
+            resourceClientGroupData.FindByClientGroupResourceResourceId(
+              clientGroup.ResourceId,
+              resource.ResourceId);
+
+          if (permOwnerUserGroupRow == null) {
+            deleted.Add(resource);
+          }
+        }
+
+        foreach (Resource resource in deleted) {
+          clientGroup.Resources.Remove(resource);
+        }
+
+        return clientGroup;
+      } else
+        return null;
+    }
+
+    private dsHiveServer.ClientGroupRow Convert(ClientGroup clientGroup,
+      dsHiveServer.ClientGroupRow row) {
+      if (clientGroup != null && row != null) {
+        row.ResourceId = clientGroup.ResourceId;
+
+        //update references
+        foreach (Resource resource in clientGroup.Resources) {
+          //first update the member to make sure it exists in the DB
+          if (resource is ClientInfo) {
+            ClientAdapter.UpdateClient(resource as ClientInfo);
+          } else if (resource is ClientGroup) {
+            UpdateClientGroup(resource as ClientGroup);
+          }
+
+          //secondly check for created references
+          dsHiveServer.ClientGroup_ResourceRow resourceClientGroupRow =
+            resourceClientGroupData.FindByClientGroupResourceResourceId(
+                            clientGroup.ResourceId,
+                            resource.ResourceId);
+
+          if (resourceClientGroupRow == null) {
+            resourceClientGroupRow =
+              resourceClientGroupData.NewClientGroup_ResourceRow();
+
+            resourceClientGroupRow.ResourceId =
+              resource.ResourceId;
+            resourceClientGroupRow.ClientGroupResource =
+              clientGroup.ResourceId;
+
+            resourceClientGroupData.AddClientGroup_ResourceRow(
+              resourceClientGroupRow);
+          }
+        }
+
+        //thirdly check for deleted references
+        IEnumerable<dsHiveServer.ClientGroup_ResourceRow> clientGroupRows =
+          from permOwner in
+            resourceClientGroupData.AsEnumerable<dsHiveServer.ClientGroup_ResourceRow>()
+          where permOwner.ClientGroupResource == clientGroup.ResourceId
+          select permOwner;
+
+        ICollection<dsHiveServer.ClientGroup_ResourceRow> deleted =
+          new List<dsHiveServer.ClientGroup_ResourceRow>();
+
+        foreach (dsHiveServer.ClientGroup_ResourceRow resourceClientGroupRow in
+          clientGroupRows) {
+          Resource resource = null;
+
+          IEnumerable<Resource> resources =
+            from r in
+              clientGroup.Resources
+            where r.ResourceId == resourceClientGroupRow.ResourceId
+            select r;
+
+          if (resources.Count<Resource>() == 1)
+            resource = resources.First<Resource>();
+
+          if (resource == null) {
+            deleted.Add(resourceClientGroupRow);
+          }
+        }
+
+        foreach (dsHiveServer.ClientGroup_ResourceRow resoruceClientGroupRow in
+          deleted) {
+          resourceClientGroupData.RemoveClientGroup_ResourceRow(
+            resoruceClientGroupRow);
+        }
+
+      }
+
+      return row;
+    }
+
     #region IClientGroupAdapter Members
-
+    [MethodImpl(MethodImplOptions.Synchronized)]
     public void UpdateClientGroup(ClientGroup group) {
-      throw new NotImplementedException();
+      if (group != null) {
+        ResourceAdapter.UpdateResource(group);
+
+        dsHiveServer.ClientGroupRow row =
+          data.FindByResourceId(group.ResourceId);
+
+        if (row == null) {
+          row = data.NewClientGroupRow();
+          row.ResourceId = group.ResourceId;
+          data.AddClientGroupRow(row);
+        }
+
+        Convert(group, row);
+      }
     }
 
     public ClientGroup GetClientGroupById(long clientGroupId) {
-      throw new NotImplementedException();
+      ClientGroup clientGroup = new ClientGroup();
+
+      dsHiveServer.ClientGroupRow row =
+        data.FindByResourceId(clientGroupId);
+
+      if (row != null) {
+        Convert(row, clientGroup);
+
+        return clientGroup;
+      } else {
+        return null;
+      }
     }
 
     public ICollection<ClientGroup> GetAllClientGroups() {
-      throw new NotImplementedException();
-    }
-
+      ICollection<ClientGroup> allClientGroups =
+        new List<ClientGroup>();
+
+      foreach (dsHiveServer.ClientGroupRow row in data) {
+        ClientGroup clientGroup = new ClientGroup();
+
+        Convert(row, clientGroup);
+        allClientGroups.Add(clientGroup);
+      }
+
+      return allClientGroups;
+    }
+
+    public ICollection<ClientGroup> MemberOf(Resource resource) {
+      ICollection<ClientGroup> clientGroups =
+        new List<ClientGroup>();
+
+      if (resource != null) {
+        IEnumerable<dsHiveServer.ClientGroup_ResourceRow> clientGroupRows =
+         from clientGroup in
+           resourceClientGroupData.AsEnumerable<dsHiveServer.ClientGroup_ResourceRow>()
+         where clientGroup.ResourceId == resource.ResourceId
+         select clientGroup;
+
+        foreach (dsHiveServer.ClientGroup_ResourceRow clientGroupRow in
+          clientGroupRows) {
+          ClientGroup clientGroup =
+            GetClientGroupById(clientGroupRow.ClientGroupResource);
+          clientGroups.Add(clientGroup);
+        }
+      }
+
+      return clientGroups;
+    }
+
+    [MethodImpl(MethodImplOptions.Synchronized)]
     public bool DeleteClientGroup(ClientGroup group) {
-      throw new NotImplementedException();
+      if (group != null) {
+        dsHiveServer.ClientGroupRow row =
+          data.FindByResourceId(group.ResourceId);
+
+        if (row != null) {
+          ICollection<dsHiveServer.ClientGroup_ResourceRow> deleted =
+            new List<dsHiveServer.ClientGroup_ResourceRow>();
+
+          foreach (dsHiveServer.ClientGroup_ResourceRow resourceClientGroupRow in
+            resourceClientGroupData) {
+            if (resourceClientGroupRow.ClientGroupResource == group.ResourceId ||
+              resourceClientGroupRow.ResourceId == group.ResourceId) {
+              deleted.Add(resourceClientGroupRow);
+            }
+          }
+
+          foreach (dsHiveServer.ClientGroup_ResourceRow resourceClientGroupRow in
+            deleted) {
+            resourceClientGroupData.RemoveClientGroup_ResourceRow(
+              resourceClientGroupRow);
+          }
+
+          data.RemoveClientGroupRow(row);
+          return ResourceAdapter.DeleteResource(group);
+        }
+      }
+
+      return false;
     }
 
Index: trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/UserGroupAdapter.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/UserGroupAdapter.cs	(revision 964)
+++ trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/UserGroupAdapter.cs	(revision 965)
@@ -112,5 +112,6 @@
             }
 
-            userGroup.Members.Add(permissionOwner);
+            if(permissionOwner != null)
+              userGroup.Members.Add(permissionOwner);
           }
         }
Index: trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/dsHiveServer.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/dsHiveServer.Designer.cs	(revision 964)
+++ trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/dsHiveServer.Designer.cs	(revision 965)
@@ -38,4 +38,8 @@
         private PermissionOwner_UserGroupDataTable tablePermissionOwner_UserGroup;
         
+        private ClientGroupDataTable tableClientGroup;
+        
+        private ClientGroup_ResourceDataTable tableClientGroup_Resource;
+        
         private global::System.Data.DataRelation relationClient_is_a_Resource;
         
@@ -47,4 +51,10 @@
         
         private global::System.Data.DataRelation relationR_57;
+        
+        private global::System.Data.DataRelation relationClientGroup_is_a_Resource;
+        
+        private global::System.Data.DataRelation relationR_52;
+        
+        private global::System.Data.DataRelation relationR_59;
         
         private global::System.Data.SchemaSerializationMode _schemaSerializationMode = global::System.Data.SchemaSerializationMode.IncludeSchema;
@@ -92,4 +102,10 @@
                     base.Tables.Add(new PermissionOwner_UserGroupDataTable(ds.Tables["PermissionOwner_UserGroup"]));
                 }
+                if ((ds.Tables["ClientGroup"] != null)) {
+                    base.Tables.Add(new ClientGroupDataTable(ds.Tables["ClientGroup"]));
+                }
+                if ((ds.Tables["ClientGroup_Resource"] != null)) {
+                    base.Tables.Add(new ClientGroup_ResourceDataTable(ds.Tables["ClientGroup_Resource"]));
+                }
                 this.DataSetName = ds.DataSetName;
                 this.Prefix = ds.Prefix;
@@ -165,4 +181,22 @@
         
         [global::System.Diagnostics.DebuggerNonUserCodeAttribute()]
+        [global::System.ComponentModel.Browsable(false)]
+        [global::System.ComponentModel.DesignerSerializationVisibility(global::System.ComponentModel.DesignerSerializationVisibility.Content)]
+        public ClientGroupDataTable ClientGroup {
+            get {
+                return this.tableClientGroup;
+            }
+        }
+        
+        [global::System.Diagnostics.DebuggerNonUserCodeAttribute()]
+        [global::System.ComponentModel.Browsable(false)]
+        [global::System.ComponentModel.DesignerSerializationVisibility(global::System.ComponentModel.DesignerSerializationVisibility.Content)]
+        public ClientGroup_ResourceDataTable ClientGroup_Resource {
+            get {
+                return this.tableClientGroup_Resource;
+            }
+        }
+        
+        [global::System.Diagnostics.DebuggerNonUserCodeAttribute()]
         [global::System.ComponentModel.BrowsableAttribute(true)]
         [global::System.ComponentModel.DesignerSerializationVisibilityAttribute(global::System.ComponentModel.DesignerSerializationVisibility.Visible)]
@@ -240,4 +274,10 @@
                 if ((ds.Tables["PermissionOwner_UserGroup"] != null)) {
                     base.Tables.Add(new PermissionOwner_UserGroupDataTable(ds.Tables["PermissionOwner_UserGroup"]));
+                }
+                if ((ds.Tables["ClientGroup"] != null)) {
+                    base.Tables.Add(new ClientGroupDataTable(ds.Tables["ClientGroup"]));
+                }
+                if ((ds.Tables["ClientGroup_Resource"] != null)) {
+                    base.Tables.Add(new ClientGroup_ResourceDataTable(ds.Tables["ClientGroup_Resource"]));
                 }
                 this.DataSetName = ds.DataSetName;
@@ -307,4 +347,16 @@
                 }
             }
+            this.tableClientGroup = ((ClientGroupDataTable)(base.Tables["ClientGroup"]));
+            if ((initTable == true)) {
+                if ((this.tableClientGroup != null)) {
+                    this.tableClientGroup.InitVars();
+                }
+            }
+            this.tableClientGroup_Resource = ((ClientGroup_ResourceDataTable)(base.Tables["ClientGroup_Resource"]));
+            if ((initTable == true)) {
+                if ((this.tableClientGroup_Resource != null)) {
+                    this.tableClientGroup_Resource.InitVars();
+                }
+            }
             this.relationClient_is_a_Resource = this.Relations["Client_is_a_Resource"];
             this.relationUser_is_a_PermissionOwner = this.Relations["User_is_a_PermissionOwner"];
@@ -312,4 +364,7 @@
             this.relationR_44 = this.Relations["R_44"];
             this.relationR_57 = this.Relations["R_57"];
+            this.relationClientGroup_is_a_Resource = this.Relations["ClientGroup_is_a_Resource"];
+            this.relationR_52 = this.Relations["R_52"];
+            this.relationR_59 = this.Relations["R_59"];
         }
         
@@ -333,4 +388,8 @@
             this.tablePermissionOwner_UserGroup = new PermissionOwner_UserGroupDataTable();
             base.Tables.Add(this.tablePermissionOwner_UserGroup);
+            this.tableClientGroup = new ClientGroupDataTable();
+            base.Tables.Add(this.tableClientGroup);
+            this.tableClientGroup_Resource = new ClientGroup_ResourceDataTable();
+            base.Tables.Add(this.tableClientGroup_Resource);
             this.relationClient_is_a_Resource = new global::System.Data.DataRelation("Client_is_a_Resource", new global::System.Data.DataColumn[] {
                         this.tableResource.ResourceIdColumn}, new global::System.Data.DataColumn[] {
@@ -353,4 +412,16 @@
                         this.tablePermissionOwner_UserGroup.UserGroupIdColumn}, false);
             this.Relations.Add(this.relationR_57);
+            this.relationClientGroup_is_a_Resource = new global::System.Data.DataRelation("ClientGroup_is_a_Resource", new global::System.Data.DataColumn[] {
+                        this.tableResource.ResourceIdColumn}, new global::System.Data.DataColumn[] {
+                        this.tableClientGroup.ResourceIdColumn}, false);
+            this.Relations.Add(this.relationClientGroup_is_a_Resource);
+            this.relationR_52 = new global::System.Data.DataRelation("R_52", new global::System.Data.DataColumn[] {
+                        this.tableClientGroup.ResourceIdColumn}, new global::System.Data.DataColumn[] {
+                        this.tableClientGroup_Resource.ClientGroupResourceColumn}, false);
+            this.Relations.Add(this.relationR_52);
+            this.relationR_59 = new global::System.Data.DataRelation("R_59", new global::System.Data.DataColumn[] {
+                        this.tableResource.ResourceIdColumn}, new global::System.Data.DataColumn[] {
+                        this.tableClientGroup_Resource.ResourceIdColumn}, false);
+            this.Relations.Add(this.relationR_59);
         }
         
@@ -382,4 +453,14 @@
         [global::System.Diagnostics.DebuggerNonUserCodeAttribute()]
         private bool ShouldSerializePermissionOwner_UserGroup() {
+            return false;
+        }
+        
+        [global::System.Diagnostics.DebuggerNonUserCodeAttribute()]
+        private bool ShouldSerializeClientGroup() {
+            return false;
+        }
+        
+        [global::System.Diagnostics.DebuggerNonUserCodeAttribute()]
+        private bool ShouldSerializeClientGroup_Resource() {
             return false;
         }
@@ -449,4 +530,8 @@
         
         public delegate void PermissionOwner_UserGroupRowChangeEventHandler(object sender, PermissionOwner_UserGroupRowChangeEvent e);
+        
+        public delegate void ClientGroupRowChangeEventHandler(object sender, ClientGroupRowChangeEvent e);
+        
+        public delegate void ClientGroup_ResourceRowChangeEventHandler(object sender, ClientGroup_ResourceRowChangeEvent e);
         
         /// <summary>
